package henrik.com.bt;


import java.io.IOException;
//import java.rmi.RemoteException;

import javax.bluetooth.*;
import javax.swing.JTextArea;
//import javax.xml.rpc.ServiceException;
import java.util.ArrayList;
import gps.*;
//import gps.parser.Tokenizer;
//import java.util.NoSuchElementException;

/**
 * 
 * This is the main class
 * referred to as CH Context Harverster
 * in the Master Thesis report.
 * 
 * This is the class holding the main method.
 * The application, CH, commuincates with 
 * a webservice oriented context gateway
 * at a remote server. It allso reads gps data
 * from a bluetooth gps receiver.
 * @author Henrik Davidsen
 */



public class CH {
	public JTextArea textArea;
	public static CHgui gui1;
	public static ArrayList DeviceFunnet; //Array used to check wether context profile has changed or not
	public static ArrayList DeviceAndService; //Array used to send to contextUpdater method. Contains information in 
	public static ArrayList RemoteDeviceArray;
	public static int ArrayUpdateCheck = 0;
	private static int LastUpdateArray = 0;
	public static ContextUpdater contextUpdater;
	public static String MAC;
	public static GPS gps1;
	public static Service1Soap proxyService;
	

	/**
	 * Starting CH by getting Bluetooth local device, and
	 * activate inquiry, at the same time as a new gps reader
	 * thread is created and started
	 * @author Henrik Davidsen
	 */
	
	
	
	
	
	
	
	public static void main(String[] args) {
	    LocalDevice l;
	    gui1 = new CHgui();
	    DeviceFunnet = new ArrayList();
	    contextUpdater = new ContextUpdater();
	    DeviceAndService = new ArrayList();
	    RemoteDeviceArray = new ArrayList();
	    GPSreader reader = new GPSreader();
	    
	    
	    //System.out.println("gps1 created");
	    gps1  = reader.printRecord();
	    gui1.getGPS(gps1);
	    
	    try {
	 
	    	l = LocalDevice.getLocalDevice();
	    	MAC = LocalDevice.getLocalDevice().getBluetoothAddress();
	    	//System.out.println("MAC har verdi" +MAC);
	    
	    } catch(BluetoothStateException e) {
	        System.err.println("Cannot get local device: " + e);
	        return;
	    }
	    
	   
	    
	    System.out.println("Local btaddr is " + l.getBluetoothAddress());
	    System.out.println("Local name is " + l.getFriendlyName());
	   
	    
	    
	    BluetoothInquirer bi = new BluetoothInquirer();
	    int Teller = 0;
	    while(true) {
	        System.out.println("Starting inquiry");
	        Teller++;
            if(Teller == 2){
            	
            	
            	contextUpdater.updateCM(DeviceAndService,RemoteDeviceArray, MAC, gps1);
            	//System.out.println("CH activates CM udpate check");
            	
            	DeviceAndService.clear();
            	RemoteDeviceArray.clear();
            	
            	DeviceFunnet.clear();
            	Teller = 0;
            	
            }
	        
	        if(!bi.startInquiry()) break;

	        while(bi.inquiring) {
		        try {
		            Thread.sleep(20); //stod p 50
		        } catch(Exception e) {
		        }
	        }
	    }
	    
	    
	    
	    
	}
	
	public static class BluetoothInquirer implements DiscoveryListener {
	    boolean inquiring;

	    public boolean startInquiry() {
	        try {
	            LocalDevice.getLocalDevice().getDiscoveryAgent().startInquiry(DiscoveryAgent.GIAC,this);
	        } catch(BluetoothStateException e) {
		        System.err.println("Cannot start inquiry: " + e);
		        return false;
		    }
	        inquiring=true;
	        
	        
	        
	     
	        return true;
	    }
        
	    
	    /**
		 * 
		 * Called when device is discvored in an 
		 * inquiry
		 * @author Henrik Davidsen
		 */
	    
	    
	    
	    
	    
	    
	    public void deviceDiscovered(RemoteDevice btDevice, DeviceClass cod) {
            StringBuffer name;
            try {
                name=new StringBuffer(btDevice.getFriendlyName(true));
            } catch(IOException ioe) {
                name=new StringBuffer();
            }
            //String namestring = name.toString();
          	while(name.length() < 20) name.append(' ');
            //System.out.println("Str p array fr den skiver ut til skjerm oppdaget dev : " +DeviceFunnet.size());
          	System.out.println("Found " + btDevice.getBluetoothAddress() + " : " + name + " : " + cod);
            
          	
         
          	
          	
          	
          
            if(DeviceFunnet.size() == 0){
            	gui1.renseFelt();
            	//String entry = btDevice.getBluetoothAddress().toString().trim()+":"+ cod.toString().trim();
            	//entry = entry.trim();
            	//DeviceAndService.add(entry);
            	 //String entry = cod.toString().trim();
            	 DeviceAndService.add(cod);
            	 RemoteDeviceArray.add(btDevice);
            	 
            	
            	DeviceFunnet.add(name.toString().trim());//alternativt og funker
            	
            	gui1.skrivtilfelt("Device found :"+name + "\n");
            	
            }
            else{
            	
            	
            	
            	//System.out.println("Strrelse p array er " +DeviceFunnet.size());
            	
            
            	for (int n = 0; n < DeviceFunnet.size(); n++){
            	
            	
            	if(DeviceFunnet.get(n).toString().trim().equals(name.toString().trim())){
            	
            		//System.out.println("Finnes i liste");
//            		String namestring = name.toString();
//            		namestring = namestring.trim();
            		break;
            	
            	}
            	
            	
            	
            	
            	else if(( n ==DeviceFunnet.size()-1)&&(DeviceFunnet.get(n).toString().trim() != name.toString().trim())) {
            		
            		//String entry = btDevice.getBluetoothAddress().toString().trim()+":"+ cod.toString().trim();
                	//entry = entry.trim();
                	
                	
                	//DeviceAndService.add(entry);
                	//DeviceFunnet.add(entry);
            		 //String entry = cod.toString().trim();
                	 DeviceAndService.add(cod);
                	 RemoteDeviceArray.add(btDevice);
                	
                	DeviceFunnet.add(name.toString().trim()); //alternativt og funker 
            		
            		
            		
            		gui1.skrivtilfelt("Device found :"+name + "\n");
            		
            	}
            	
            	
            	
            	else  {
            		
            		
            		
            		//System.out.println("har vrt igjennom en runde i for, uten resultat");
            	    // tror vi kan nullstille alt bde skjerm og array her....
            		// evt ogs oppdatere CM
            		
            		
            		
            		//ArrayUpdateCheck = DeviceFunnet.size();
            		//DeviceFunnet.clear();
            		
            		
            	}//slutt else
            	
            	}//slutt for
           
            
            
            }//slutt ifelse
        
        
        }
       
        /**
    	 * Calling update method in order to check
    	 * whether the device array of received devices
    	 * is changed since last update against CM
    	 * @author Henrik Davidsen
    	 */
        
        
        
        
        public void updateCM(int ArrayUpdate){
    	   
        int newArraySize = ArrayUpdate;	
        	
        if  (LastUpdateArray != newArraySize){
        	
        	System.out.println("updating CM with new devices");
        	
        	}
        else{
        	
        	System.out.println("No new devices since last update");
        		
        	
        }
        	
        	
        	
        	
    	   
    	   
    	   
       }
        
        public String getMAC(){
        	return MAC;
        }
        
        public LocalDevice getLocal(LocalDevice loc){
    		
    		return loc;	
    	}
        
        public GPS getGPS(GPS gps){
        	GPS GUIgps = gps;
        	return GUIgps;
        
        }
        
       
        
        
        public void servicesDiscovered(int transID, ServiceRecord[] servRecord) {
        }

        public void serviceSearchCompleted(int transID, int respCode) {
        }

        public void inquiryCompleted(int discType) {
            inquiring=false;
        }
        
    
        
        
        
        
	    
	}
}
