package henrik.com.bt;

import java.io.*;
import java.rmi.RemoteException;
import java.util.*;
import gps.*;
//import java.io.PrintStream;
import java.io.FileOutputStream;
import java.io.FileInputStream;

import javax.xml.rpc.ServiceException;
//import java.io.FileReader;
import java.io.IOException;
import javax.bluetooth.*;
import javax.bluetooth.DeviceClass;




/**
 * 
 * This class writes xml to file
 * from input arraylist, and 
 * calls the webservice context gateway
 * with a string parameer of this xml structure,
 * and Local MAC of BT Context Harvester CH
 * @author Henrik Davidsen
 */

public class XMLwrite {
	
	//public FileInputStream bytereader;
	//public byte[] byte1;
	public String contextString;
	public CODorganizer org;
	
	

	/**
	 * writes the information from the device
	 * array to xml and includes the services of
	 * these device. Also includes the frequent
	 * updated gps variables, providing the 
	 * most up to date position.
	 * 
	 * The xml write converts the xml object to a string
	 * and inculdes this in a webservice update method call,
	 * also including the local blutooth mac of CH.
	 * The xml structured string is also written locally 
	 * at CH to file.
	 * @author Henrik Davidsen
	 */
	
	
	
	public XMLwrite(String inLocalMac){
		
		String localMac = inLocalMac;
		org = new CODorganizer();
		
	}
	
	
	
		public void updateremote(String inLocalMac){
		Service1Locator proxy = new Service1Locator();
    	String localMac = inLocalMac;
    	
    	
    	try {
    		
    		//String filename2 = "MACaddress.xml"; 
 	        //bytereader = new FileInputStream(filename2);
    		
    		//String in = "hei fra CM p webservice som skriver til fil";
  			Service1Soap proxy1 = proxy.getService1Soap();
  			System.out.println("Proxy generated i XMLwrite :");
  			System.out.println("Contact with CM : " +proxy1.helloWorld());
  			
  			
  			if(contextString!=null){
  			
  			String newstring = proxy1.uploadContext(contextString,localMac);
  			System.out.println("WS wrote to xml file at CM");
  			System.out.println(newstring);}
  			else{System.out.println("contextString was null");}
  			
  			
  			
  			
  			
  			
  		} 
    	
    	catch (IOException e ){System.out.println("ioe");}
    	
    	catch (ServiceException e1) {
  			// TODO Auto-generated catch block
  			e1.printStackTrace();
  		} 
    	
    	//catch (RemoteException e) {
  			// TODO Auto-generated catch block
  			//e.printStackTrace();
  		//}		
		
	}


	

	  public void writetoFile(ArrayList inDeviceAndService, ArrayList inRemoteDeviceArray, String inMAC, GPS gps){
	   
		  String gpsData1;
		  String gpsData2;
		  String gpsData3;
		  String gpsData4;
		  String gpsData5;
		  String gpsData6 = "false";
		  String filename = inMAC;
		  filename = filename+".xml";
		  
		  
		  
		  
		 
		  
		  
		  
		  if(
			gps.getWarning()== false     
			
		  	)
		  
			  
		  {
			  //System.out.println("gr inn i warning false og proever skrive obj");
			  gpsData1 = gps.getGPSdata1();
			  gpsData2 = gps.getGPSdata2();
			  
			  //String gpsData1b = gpsData1;
			  //String gpsData2b = gpsData2;
			  
			  
			  
			  //String lat = gpsData1b.substring(0,1)+" "+gpsData1b.substring(2,3)+"' "+gpsData1b.substring(4,5)+"."+gpsData1b.substring(5,5); 
			  //String lon = gpsData2b.substring(0,2)+" "+gpsData2b.substring(3,4)+"' "+gpsData2b.substring(5,6)+"."+gpsData2b.substring(6,7); 
			  
			  //System.out.println("Latitude N:  " + lat);
			  //System.out.println("Longitude E: " + lon);
			  //System.out.println("N " + lat + "E " + lon);
			  
			  gpsData3 = gps.getGPSdata3();
			  gpsData4 = gps.getGPSdata4();
			  gpsData5 = gps.getGPSdata5();
			  
			  
			  
		  }
		  
		  
		  else if(gps.getWarning()== true && gps.getGPSdata1() == null)
		  {
			  gpsData1 = "No GPS signals available";
			  gpsData2 = "No GPS signals available";
			  gpsData3 = "No GPS signals available";
			  gpsData4 = "No GPS signals available";
			  gpsData5 = "No GPS signals available";
			  
			  
			  
			  
			  System.out.println("gpsData is yet not ready");
		  }
		  
		  else{
			  
			  gpsData1 = gps.getGPSdata1();
			  gpsData2 = gps.getGPSdata2();
			  gpsData3 = gps.getGPSdata3();
			  gpsData4 = gps.getGPSdata4();
			  gpsData5 = gps.getGPSdata5();
			  
			  if(gps.getWarning())
			  gpsData6 = "true";
			  else
				gpsData6 = "false";  
			  
		  }
		
		  
	      
	      try {        
	        OutputStream fout= new FileOutputStream(filename);
	        OutputStream bout= new BufferedOutputStream(fout);
	        OutputStreamWriter out 
	         = new OutputStreamWriter(bout, "8859_1");
	        StringBuffer stringOut = new StringBuffer();
	        
	      
	        out.write("<?xml version=\"1.0\" ");
	        out.write("encoding=\"ISO-8859-1\"?>\r\n");  
	        
	        stringOut.append("<?xml version=\"1.0\" ");
	        stringOut.append("encoding=\"ISO-8859-1\"?>\r\n");
	        
	        
	        out.write("<Context>\r\n");  
	        stringOut.append("<Context>\r\n"); 
	        
	      
	        
	        //out.write("  <service index=\"" + i + "\">");
	        //out.write("</service>\r\n");

	        for (int i = 0; i < inRemoteDeviceArray.size(); i++) {
	          RemoteDevice remD = (RemoteDevice)inRemoteDeviceArray.get(i);
	        	
	          out.write("  <device MAC=\"" + remD.getBluetoothAddress().trim() + "\">");
	          //out.write("service"+ remD.getBluetoothAddress());
	          
	          stringOut.append("  <device MAC=\"" + remD.getBluetoothAddress().trim() + "\">");
	          //stringOut.append("service"+ remD.getBluetoothAddress());
	          
	          //System.out.println("kommer til der serviceArray init i xmlwrite");
	          ArrayList serviceArray = org.getServiceArray((DeviceClass)inDeviceAndService.get(i));
	          
			          	for (int n = 0; n < serviceArray.size(); n++){
			          
					          //out.write("<service=\"" + n + "\">");
					          out.write("<service>\n");
			          		  out.write(serviceArray.get(n).toString().trim());
					          out.write("</service>\n");   
					          
					          stringOut.append("<service>\n");
					          stringOut.append(serviceArray.get(n).toString().trim());
					          stringOut.append("</service>\n"); 
					         
			          	}
	          
	          
	         
	          
	          
	          
	          //stringOut.append("  <device MAC =\"" + i + "\">");
	          //stringOut.append("service"+ remD.getBluetoothAddress());
	          stringOut.append("</device>\r\n");
	          
	          //out.write("  <device MAC =\"" + i + "\">");
	          //out.write("service"+ remD.getBluetoothAddress());
	          out.write("</device>\r\n");
	          
	         
	        
	        
	        }//slutt for
	        
	        
	        
	        
	        out.write("<GPSlocation>\n");
	        stringOut.append("<GPSlocation>\n");	
	        	out.write("<lattitude>\n");
	        	out.write(gpsData1);
	        	out.write("</lattitude>\n");
	        	stringOut.append("<lattitude>\n");
	        	stringOut.append(gpsData1);
	        	stringOut.append("</lattitude>\n");
	        	
	        	
	        	
	        	
	        	
	        	
	        	out.write("<lattitudeDirection>\n");
	        	out.write(gpsData2);
	        	out.write("</lattitudeDirection>\n");
	        	stringOut.append("<lattitudeDirection>\n");
	        	stringOut.append(gpsData2);
	        	stringOut.append("</lattitudeDirection>\n");
	        	
	        	
	        	
	        	
	        	
	        	out.write("<longitude>\n");
	        	out.write(gpsData3);
	        	out.write("</longitude>\n");
	        	stringOut.append("<longitude>\n");
	        	stringOut.append(gpsData3);
	        	stringOut.append("</longitude>\n");
	        	
	        	
	        	
	        	
	        	out.write("<longitudeDirection>\n");
	        	out.write(gpsData4);
	        	out.write("</longitudeDirection>\n");
	        	stringOut.append("<longitudeDirection>\n");
	        	stringOut.append(gpsData4);
	        	stringOut.append("</longitudeDirection>\n");
	        	
	        	
	        	
	        	
	        	out.write("<groundSpeed>\n");
	        	out.write(gpsData5);
	        	out.write("</groundSpeed>\n");
	        	
	        	
	        	stringOut.append("<groundSpeed>\n");
	        	stringOut.append(gpsData5);
	        	stringOut.append("</groundSpeed>\n");
	        	
	        	
	        	
	        	
	        	
	        	
	        	out.write("<gpsSignalweak>\n");
	        	out.write(gpsData6);
	        	out.write("</gpsSignalweak>\n");
	        	stringOut.append("<gpsSignalweak>\n");
	        	stringOut.append(gpsData6);
	        	stringOut.append("</gpsSignalweak>\n");
	        	
	        	
	        	
	        	
	        	
	        
	        	
	        	
	        out.write("</GPSlocation>\n");
	        stringOut.append("</GPSlocation>\n");
	        
	        
	        
	        out.write("</Context>\r\n");
	        stringOut.append("</Context>\r\n");
	        contextString = stringOut.toString();
	        //hva med  bare sette out.write(contextString)
	        //og droppe alle out prosessene underveis?
	        this.updateremote(inMAC);
	        
	        //System.out.println(contextString);
	        
	    out.flush();
	   
	    out.close();
	        
	        
	      
	      }
	      catch (UnsupportedEncodingException e) {
	        System.out.println(
	         "This VM does not support the Latin-1 character set."
	        );
	      }
	      catch (IOException e) {
	        System.out.println(e.getMessage());        
	      }

	  }

	

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

}
